SystemOrganization addCategory: #'Employee-Example2'!

Object subclass: #Employee
	instanceVariableNames: 'empName empNum empSkills'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Employee-Example2'!

!Employee methodsFor: 'adding' stamp: 'kl 10/16/2008 10:30'!
addSkill: aSkill
      empSkills add: aSkill.
      ^ self.
! !

!Employee methodsFor: 'getting' stamp: 'kl 10/16/2008 09:42'!
empNum
      ^empNum
! !

!Employee methodsFor: 'setting' stamp: 'kl 10/16/2008 10:59'!
empNum: anEmpNum		
   "Employee numbers must be between 1000 and 1999."
   "This is a corporate regulation."
      ((anEmpNum >= 1000) and: [anEmpNum <= 1999])
         ifTrue: [
            empNum := anEmpNum.
            ^self
         ]
         ifFalse: [
            self error: 'Invalid employee number'
         ]
! !

!Employee methodsFor: 'testing' stamp: 'kl 10/16/2008 09:44'!
hasSkill: aSkill
      ^(empSkills occurrencesOf: aSkill) = 1
! !

!Employee methodsFor: 'initialize-release' stamp: 'kl 10/16/2008 10:34'!
initialize
      empName := 'Hunoz'.
      empNum := 0.
      empSkills := Set new.
      	^self
! !

!Employee methodsFor: 'getting' stamp: 'kl 10/16/2008 09:42'!
name
      ^empName
! !

!Employee methodsFor: 'setting' stamp: 'kl 10/16/2008 09:42'!
name: aName
      empName := aName.
! !

!Employee methodsFor: 'printing' stamp: 'kl 10/16/2008 11:00'!
print
      Transcript show: ('Employee name ', empName);cr .
      Transcript show: ('Employee number: ', empNum asString);cr .
       Transcript show:  ('Salary:          ', self slary asString);cr.
      Transcript show:  'Skills:';cr.
                empSkills do: [:x | Transcript show: ('   ', x asString);cr ].

     
! !

!Employee methodsFor: 'getting' stamp: 'kl 10/16/2008 09:43'!
salary
      self subclassResponsibility.
! !

!Employee methodsFor: 'setting' stamp: 'kl 10/16/2008 11:01'!
salary: aSalary
      self subclassResponsibility.
! !

Employee subclass: #HourlyEmployee
	instanceVariableNames: 'hourlyRate numberOfHours'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Employee-Example2'!

!HourlyEmployee methodsFor: 'as yet unclassified' stamp: 'kl 10/21/2008 16:08'!
addHours: numHours
      numberOfHours := numberOfHours + numHours

! !

!HourlyEmployee methodsFor: 'as yet unclassified' stamp: 'kl 10/21/2008 16:07'!
initialize
      super initialize.
      hourlyRate := 0.
      numberOfHours := 0.
      ^self
! !

!HourlyEmployee methodsFor: 'as yet unclassified' stamp: 'kl 10/21/2008 16:08'!
rate: aRate
      hourlyRate := aRate
! !

!HourlyEmployee methodsFor: 'as yet unclassified' stamp: 'kl 10/21/2008 16:07'!
salary
      ^hourlyRate * numberOfHours
! !

!HourlyEmployee methodsFor: 'as yet unclassified' stamp: 'kl 10/21/2008 16:08'!
setHours: numHours
      numberOfHours := numHours
! !

Employee subclass: #MonthlyEmployee
	instanceVariableNames: 'monthlySalary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Employee-Example2'!

!MonthlyEmployee methodsFor: 'as yet unclassified' stamp: 'kl 10/21/2008 16:01'!
initialize
   super initialize.
   monthlySalary := 0.
   ^self.! !

!MonthlyEmployee methodsFor: 'as yet unclassified' stamp: 'kl 10/21/2008 16:01'!
salary
      ^monthlySalary
! !

!MonthlyEmployee methodsFor: 'as yet unclassified' stamp: 'kl 10/21/2008 16:01'!
salary: aSalary
      monthlySalary := aSalary.
! !

Object subclass: #EmployeeDataBase
	instanceVariableNames: 'employees'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Employee-Example2'!

!EmployeeDataBase methodsFor: 'adding' stamp: 'kl 10/16/2008 11:56'!
add: anEmployee
      (anEmployee isKindOf: Employee)
           ifTrue: [
            employees
               at: (anEmployee empNum)
               put: anEmployee.
            ^self
         ]
         ifFalse: [
            self error: 'You can add employees only!!'
         ]
! !

!EmployeeDataBase methodsFor: 'enumerating' stamp: 'kl 10/16/2008 09:45'!
do: aBlock
      employees do: aBlock.
! !

!EmployeeDataBase methodsFor: 'testing' stamp: 'kl 10/16/2008 09:45'!
findSkill: aSkill
      | empsWithSkill |
      empsWithSkill := Set new.
      employees do: [
          :emp |
          (emp hasSkill: aSkill)
             ifTrue: [empsWithSkill add: emp]].
      ^empsWithSkill.
! !

!EmployeeDataBase methodsFor: 'initialize-release' stamp: 'kl 10/16/2008 11:56'!
initialize
      employees := Dictionary new! !
